Rem $Title:    'Perpetual Inventory System. Update and Maintenence.'
Rem $Page
HouseKp: Cls
         Lprint chr$(027);chr$(048);chr$(027);chr$(15);
         ZO$   = Mki$(0)
         M3    = 50
         M1    = 200
         Dim   I1$(M1),R1(M1),U$(12)
         Color 10
         Print "Enter Inventory File Name ";
         Color 15
         Input F$
         GoSub OpenF
Main:    Cls
         Color 10
         Print "The Following Options are Available:"
         Color 15
         Print
         Print Tab(5);"1..Item List (With Record Numbers)"
         Print Tab(5);"2..Add New Items"
         Print Tab(5);"3..Correct Item Information"
         Print Tab(5);"4..Query and Update"
         Print Tab(5);"5..Report Program"
         Print
         O1$ = ""
         Color 10: Print "Enter Option ";: Color 15: Input O1$
         If    O1$ = "1" then GoSub ItemL
         If    O1$ = "2" then GoSub AddI
         If    O1$ = "3" then GoSub CorrI
         If    O1$ = "4" then GoSub QueryU
         If    O1$ = "5" then Chain "CSINVRPT.EXE"
         Cls
         Color 10: Print "Do you wish to continue (Y or N) ";
         Color 15: Input A1$
         Cls
         If    A1$ = "Y" or A1$ = "y" then GoTo Main
         Close
         Locate 12,1: Color 4: Print "File Closed, Processing Complete": Color 15
         Lprint chr$(027);chr$(050);chr$(027);chr$(18)
         End
'------------------------------------------------------------------------------
OpenF:   Open  "R",1,F$,128
         Field #1, 2 as Z$, 8 as I$, 30 as D$, 2 as O$, 4 as V$, 4 as L$, 4 as C$
         For   I = 1 to 12 Step 1
               Field #1, (((I-1)*2)+54) as X1$, 2 as U$(I) '54 thru 77(0) X1$=Dummy
         Next  I
         Field #1, 78 as X1$, 2 as UO$, 2 as RO$, 4 as P$, 4 as CO$, 2 as R$
         Get   #1,1
         L1    = Cvi(Z$)
         If    L1 < 1 then L1 = 1
         I     = 1
         For   K = 2 to Lof(1)/128
               GoSub ReadF
               If Z$ <> "**" then GoTo OpenF.1
               I1$(I) = I$
               R1(I) = K
               I = I + 1
OpenF.1: Next  K
         M3    = I - 1
         Return
'------------------------------------------------------------------------------
ReadF:   Get   #1,K
         Lset  R$  = Mki$(R)
         O     = Cvi(O$)
         V     = Cvs(V$)
         UO    = Cvi(UO$)
         P     = Cvs(P$)
         CO    = Cvs(CO$)
         RO    = Cvi(RO$)
         R     = Cvi(R$)
         Return
'------------------------------------------------------------------------------
FindI:   K     = 0
         For   I = 1 to M3 Step 1
               If I9$ = I1$(I) then GoTo FI.1
         Next  I
         Color  4: Locate 25,1: Print "Item not Found";
         Color 15: Print "  Continue ";: Input G$
         Cls
         GoTo  FI.2
FI.1:    K     = R1(I)
FI.2:    Return
'------------------------------------------------------------------------------
WriteF:  Lset  O$  = Mki$(O)
         Lset  V$  = Mks$(V)
         Lset  UO$ = Mki$(UO)
         Lset  P$  = Mks$(P)
         Lset  CO$ = Mks$(CO)
         Lset  RO$ = Mki$(RO)
         Lset  R$  = Mki$(R)
         Put   #1,K
         Return
'------------------------------------------------------------------------------
AddI:    Cls
         Print "***** Add New Inventory Items *****"
         Color 10
         Locate  3,1: Print "Enter the Stock Item Number ";
         Locate  4,1: Print "         Item Description = ";
         Locate  5,1: Print "           Amount on Hand = ";
         Locate  6,1: Print "                Unit Cost = ";
         Locate  7,1: Print "            Location Code = ";
         Locate  8,1: Print "     Inventory Class Code = ";
         Locate  9,1: Print "            Reorder Point = ";
         Color 15
AI.1:    I9$   = "": Locate 3,30: Input I9$
         If    I9$ = "" or I9$ = "Q" or I9$ = "q" then GoTo AI.2
         M3    = M3 + 1
         If    Len(I9$) < 8 then I9$ = I9$ + Space$(8 - Len(I9$))
         I1$(M3) = I9$
         Locate 4,30: Input D9$
         GoSub FindR
         Locate  5,30: Input O
         Locate  6,30: Input V
         Locate  7,30: Input L9$
         Locate  8,30: Input C9$
         Locate  9,30: Input R
         P = V
         For   I = 1 to 12 Step 1
               Lset U$(I) = ZO$
         Next  I
         Lset  D$ = D9$
         Lset  I$ = I9$
         Lset  Z$ = "**"
         Lset  L$ = L9$
         Lset  C$ = C9$
         CO    = 0
         R1(M3)= K1
         K     = K1
         GoSub WriteF
         K     = 1
         Lset  Z$ = Mki$(L1)
         GoSub WriteF
         Locate  3,29: Print "                                   ";
         Locate  4,29: Print "                                   ";
         Locate  5,29: Print "                                   ";
         Locate  6,29: Print "                                   ";
         Locate  7,29: Print "                                   ";
         Locate  8,29: Print "                                   ";
         Locate  9,29: Print "                                   ";
         GoTo  AI.1
AI.2:    Cls
         Return
'------------------------------------------------------------------------------
FindR:   I     = 2
         J     = 1
FR.1:    If    I <= L1 then GoTo FR.2
         L1    = L1 + 1
         I     = L1 + 1
         GoTo  FR.3
FR.2:    K     = I
         GoSub ReadF
         I     = I + 1
         If    Z$ = "**" then GoTo FR.1
FR.3:    K1    = I - 1
         Return
'------------------------------------------------------------------------------
QueryU:  Cls
QU.1:    K     = 0
         Color 15: Locate 1,1: Print "*****     Query and Update    *****";
         Locate 3,1: Print "                                                                            ";
         Color 10: I9$   = "": Locate  3,1: Print "Item Number = ";
         Color 15: Locate 3,16: Input I9$
         Locate 3,1: Print "                                     ";
         If    I9$ = "Q" or I9$ = "q" then GoTo QU.10
         L9    = Len(I9$)
         If    L9 < 8 then I9$ = I9$ + Space$(8 - L9)
         GoSub FindI
         If    K = 0 then GoTO QU.1
QU.2:    Locate 3,1: Color 10:
         Print "Enter Query(Q), Update(U), or Query/Update(QU) ";: Color 15
         Locate 3,49: Input T9$
         Locate 3,1: Print "                                                                            ";
         If    T9$ = "Q" or T9$ = "q" or T9$ = "U" or T9$ = "u" or T9$ = "QU" or T9$ = "qu" then GoTo QU.3
         GoTo  QU.2
QU.3:    GoSub ReadF
         If    T9$ = "U" or T9$ = "u" then GoTo QU.4
'
'        Query Record
'
         Locate 5,1: Color 10: Print "Stk #"; Tab(10); "Description"; Tab(41); "On Hand"; Tab(50); "Price"; Tab(60); "Location";
         Locate 7,1: Color 15: Print      I$; Tab(10);            D$; Tab(41);         O; Tab(50);       P; Tab(60);         L$;
QU.4:    If    T9$ = "Q" or T9$ = "q" then GoTo QU.9
'
'        Update Record
'
QU.5:    T8$   = ""
         Locate 3,1: Color 10: Print "Item Received (R) , or Used (U) ";
         Locate 3,33: Color 15: Input T8$
         If    T8$ = "R" or T8$ = "r" or T8$ = "U" or T8$ = "u" then GoTo QU.6
         GoTo  QU.5
QU.6:    Q     = 0
         Locate 3,1: Color 10: Print "Enter Quantity                      ";
         Locate 3,16: Color 15: Input Q
         If    T8$ = "R" or T8$ = "r" then GoTo QU.7
         UO    = UO + Q
         CO    = CO + (Q * V)
         Lset  CO$ = Mks$(CO)
         O     = O - Q
         Locate 15,1: Color 10: Print "Balance is:";:Color 14: Print O;: Color 15
         GoTo  QU.8
QU.7:    RO    = RO + Q
         Locate 3,1: Color 10: Print "Enter Unit Price                    ";
         Locate 3,18: Color 15: Input P9
         V9    = (((Q * P9) + (O * V)) / (O + Q))
         Locate 15,1: Color 10: Print "Inventory Value Old = ";:Color 14:Print V;
         Locate 16,1: Color 10: Print "Inventory Value New = ";:Color 14:Print V9;
         V     = V9
         O     = O + Q
         Locate 18,1: Color 10: Print "Balance is:";:Color 14: Print O;: Color 15
QU.8:    GoSub WriteF
QU.9:    GoTo  QU.1
QU.10:   Return
'------------------------------------------------------------------------------
ItemL:   Print "Do you want Printer Output (Y or N)";
         Input A1$
         Cls
         Locate 1,1: Print "*****   Inventory Item List   *****";
         Locate 3,1: Print string$(72,42)
         Locate 5,1: Color 10: Print "Nbr"; Tab(10); "Item"; Tab(20); "Rec #";: Color 15
         Locate 7,1
         For   I = 1 to M3 step 1
               Print I; Tab(10); I1$(I); Tab(20); R1(I)
         Next  I
         Locate 25,1: Print "Continue ";: Input G$
         If    A1$ = "N" or A1$ = "n" or A1$ = "" then GoTo IL.1
         Lprint
         Lprint "*****   Inventory Item List   *****"
         Lprint
         Lprint string$(72,42)
         Lprint
         Lprint "Nbr"; Tab(10); "Item"; Tab(20); "Rec #"
         Lprint
         For   I = 1 to M3 step 1
               Lprint I; Tab(10); I1$(I); Tab(20); R1(I)
         Next  I
IL.1:    Return
'------------------------------------------------------------------------------
CorrI:   Cls
         I9$   = ""
         Color 15: Locate 1,1: Print "*****       Corrections       *****";
         Locate 3,1: Color 10: Print "Enter Item Number ";: Color 15
         Locate 3,19:Input I9$
         If    I9$ = "" then GoTo CorrE
         L9    = Len(I9$)
         If    L9 < 8 then I9$ = I9$ + Space$(8-L9)
         GoSub FindI
         If    K = 0 then GoTo CorrI
         A1$   = ""
         Locate 5,1: Color 4: Print "Delete Item ('YES' or Any Key) ";
         Locate 5,36: Input A1$: Color 15:
         If    A1$ = "YES" then GoTo CorrQ
         Locate 5,1: Print "                                        ";
         GoTo  Cor.1
CorrQ:   A1$   = ""
         Locate 5,1: Color 20: Print "Please Confirm By Tapping the '-' key ";
         Locate 5,39: Color 15: Input A1$
         If    A1$ = "-" then GoTo CorrD
         Locate 5,1: Print "                                                ";
         GoTo  Cor.1
CorrD:   Locate 5,1: Print "Item "; I9$; " Deleted                          ";
         Lset  Z$ = "  "
         I1$(I)= "********"
         GoSub WriteF
         Locate 25,1: Print "Continue ";: Input G$
         GoTo  CorrI
Cor.1:   A1$   = ""
         Locate 3,1: Color 10: Print "Select the Information to be Changed";
         Locate 4,1: Color 14: Print "Item(I), Desc(D), Loc(L), Class(C), Price(P), Reorder(R) ";
         Locate 4,58: Color 15: Input A1$
         If    A1$ = "" then GoTo CorrI
         GoSub ReadF
'
'        Change Location
'
         If    A1$ <> "L" and A1$ <> "l" then GoTo Cor.2
         L9$   = ""
         Locate 6,1: Color 10: Print "Enter New Location ";
         Locate 6,20: Color 14: Input L9$
         Lset  L$ = L9$
         GoSub WriteF
         GoTo  CorrI
'
'        Change Description
'
Cor.2:   If    A1$ <> "D" and A1$ <> "d" then GoTo Cor.3
         D9$   = ""
         Locate 6,1: Color 10: Print "Enter New Description ";
         Locate 6,23: Color 14: Input D9$
         Lset  D$ = D9$
         GoSub WriteF
         GoTo  CorrI
'
'        Change Class
'
Cor.3:   If    A1$ <> "C" and A1$ <> "c" then GoTo Cor.4
         C9$   = ""
         Locate 6,1: Color 10: Print "Enter New Class ";
         Locate 6,17: Color 14: Input C9$
         Lset  C$ = C9$
         GoSub WriteF
         GoTo  CorrI
'
'        Change Price
'
Cor.4:   If    A1$ <> "P" and A1$ <> "p" then GoTo Cor.5
         P     = 0
         Locate 6,1: Color 10: Print "Enter New Price ";
         Locate 6,17: Color 14: Input P
         Lset  P$ = Mks$(P)
         GoSub WriteF
         GoTo  CorrI
'
'        Change Reorder Point
'
Cor.5:   If    A1$ <> "R" and A1$ <> "r" then GoTo Cor.6
         R     = 0
         Locate 6,1: Color 10: Print "Enter New Reorder Point ";
         Locate 6,25: Color 14: Input R
         Lset  R$ = Mki$(R)
         GoSub WriteF
         GoTo  CorrI
'
'        Change Item Number
'
Cor.6:   If    A1$ <> "I" and A1$ <> "i" then GoTo CorrE
         I9$   = ""
         Locate 6,1: Color 10: Print "Enter New Item Number ";
         Locate 6,23: Color 14: Input I9$
         If    Len(I9$) < 8 then I9$ = I9$ + Space$(8 - Len(I9$))
         I1$(I)= I9$
         GoSub WriteF
         GoTo  CorrI
CorrE:   Return
